
(function () {
    if (!window.openerp) {
        return;
    }

    if (!openerp.print_engine) {
        openerp.print_engine = {};
    }
    
    if (!openerp.print_engine.sockets) {
        openerp.print_engine.sockets = [];
    }

    $.get('/print_engine/sockets', function (data) {
        for (var i = 0; i < data.sockets.length; i++) {
            connect(data.sockets[i]);
        }
    });

    /**
     * 
     * @param {*} options 
     */
    var buildUrl = function(options) {
        return options.protocol + '://' + options.host + ':' + options.port + options.path 
    }

    /**
     * Connect to websocket
     * 
     * @param {*} socket 
     */
    var connect = function (socket) {
        var url = buildUrl(socket);
        socket = new WebSocket(url);

        /**
         * 
         * @param {*} e 
         */
        socket.onopen = function (e) {
            openerp.print_engine.sockets.push({
                instance: this,
                status: 'online'
            });
        }

        /**
         * 
         * @param {*} e 
         */
        socket.onclose = function (e) {
            console.log()
        }

        /**
         * 
         * @param {*} e 
         */
        socket.onerror = function (e) {
            console.log(e);
        }

        /**
         * 
         * @param {*} e 
         */
        socket.onmessage = function (e) {
            console.log(e);
        }
    }

    /**
     * Send action to printer
     * 
     * @param {*} data 
     */
    var sendToSocket = function (data) {
        data = JSON.stringify(data);

        console.log(data);
    }

    /**
     * Update printers on server
     * 
     * @param {*} data 
     */
    var updatePrinters = function (printers) {
        var data = {
            jsonrpc: '2.0',
            method: 'call',
            data: printers
        }

        $.post('/print_engine/update', data, function (response) {
            console.log(response);
        });
    }
}).call(this)